



stages:
  - install
  - build
  - deploy
  - local

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  PROJECT_PATH: "$CI_PROJECT_DIR"
  APP_OUTPUT_PATH: "$PROJECT_PATH/app"
  REGISTRY_PATH: "$REGISTRY_PATH"

install:
  stage: install
  image: node:16-alpine
  script:
    - npm install
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - npm-cache
  interruptible: true
  
build:
  stage: build
  image: node:16-alpine
  script:
    - cp $PROJECT_PATH/src/environments/environment.prod.ts.sample $PROJECT_PATH/src/environments/environment.prod.ts
    - cp $PROJECT_PATH/src/environments/environment.prod.ts.sample $PROJECT_PATH/src/environments/environment.ts
    - npm link @angular/cli@12.2
    - ng build --configuration=production
  artifacts:
    paths:
      - $CI_PROJECT_DIR/dist
  interruptible: true

deploy:
  stage: deploy
  image: docker:latest
  services:
    - docker:dind
  script:

    - >

      docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY;
    
      if [ $CI_COMMIT_BRANCH == "production" ]; then
        echo "push a $CI_COMMIT_BRANCH image"
        LATEST_IMAGE=$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH;
        docker build -t $LATEST_IMAGE .;
        docker push $LATEST_IMAGE;

      elif [ $CI_COMMIT_BRANCH == "develop" ]; then
        echo "push a $CI_COMMIT_BRANCH image"
        LATEST_IMAGE=$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH;
        docker build -t $LATEST_IMAGE .;
        docker push $LATEST_IMAGE;
      
      else
        echo "do nothing";
      
      fi

  interruptible: true

local:
  stage: local
  image: docker:latest
  services:
    - docker:dind
  script:

    - >

      docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY;
      LOCAL_IMAGE=$CI_REGISTRY_IMAGE/local:latest;
      docker build -t $LOCAL_IMAGE . -f Dockerfile.dev;
      docker push $LOCAL_IMAGE;

  only:
    - web